// interface variables
var cookiemanager = null;
var gDateService = null;

// cookies list
var cookies = [];

var cookieBundle;
var cookiesTree;
const nsICookie = Components.interfaces.nsICookie;

var lastCookieSortColumn = "";
var lastCookieSortAscending = false;

var lastsearchNameKey = "cookiemanager.lastsearch.name";
var lastsearchHostKey = "cookiemanager.lastsearch.host";

var cookiesTreeView = {
	rowCount : 0,
	setTree : function(tree){},
	getImageSrc : function(row,column) {},
	getProgressMode : function(row,column) {},
	getCellValue : function(row,column) {},
	getCellText : function(row,column){
		var rv="";
		if (column=="domainCol") {
			rv = cookies[row].rawHost;
		} else if (column=="nameCol") {
			rv = cookies[row].name;
		}
		return rv;
	},
	isSeparator : function(index) {return false;},
	isSorted: function() { return false; },
	isContainer : function(index) {return false;},
	cycleHeader : function(aColId, aElt) {},
	getRowProperties : function(row,column,prop){},
	getColumnProperties : function(column,columnElement,prop){},
	getCellProperties : function(row,prop){}
};

var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

function Startup()
{
	// intialize gDateService
	cookiemanager = Components.classes["@mozilla.org/cookiemanager;1"].getService();
	cookiemanager = cookiemanager.QueryInterface(Components.interfaces.nsICookieManager);
	if( !gDateService )
	{
		const nsScriptableDateFormat_CONTRACTID = "@mozilla.org/intl/scriptabledateformat;1";
		const nsIScriptableDateFormat = Components.interfaces.nsIScriptableDateFormat;
		gDateService = Components.classes[nsScriptableDateFormat_CONTRACTID].getService(nsIScriptableDateFormat);
	}

	var lastsearchHost = '';
	var lastsearchName = '';

	//check whether we have the host branch
	var aCount = {value:0};
	var childArray = prefs.getChildList(lastsearchHostKey, aCount);
	if( aCount.value == 0 )
		prefs.setCharPref(lastsearchHostKey, '');
	else
		lastsearchHost = prefs.getCharPref(lastsearchHostKey) || '';

	//check whether we have the name branch
	aCount.value = 0;
	childArray = prefs.getChildList(lastsearchNameKey, aCount);
	if( aCount.value == 0 )
		prefs.setCharPref(lastsearchNameKey, '');
	else
		lastsearchName = prefs.getCharPref(lastsearchNameKey) || '';
		
	document.getElementById('lookupcriterium').value = lastsearchHost;
	loadCookies( lastsearchHost );
	
	// select the last selected cookie
	for( var i=0; i<cookies.length; i++ )
	{
		if( cookies[i].name == lastsearchName )
		{
			cookiesTree.treeBoxObject.selection.select( i );
			break;
		}
	}
	
	
}

function DoLookup(e)
{
	if( e && e.keyCode == 13 || !e )
	{
		var searchfor = document.getElementById('lookupcriterium').value;
		// save value if it's not empty
		if( searchfor )
			prefs.setCharPref(lastsearchHostKey, searchfor );

		var oldCount = cookiesTreeView.rowCount;
		cookiesTreeView.rowCount = 0;
		cookiesTree.treeBoxObject.rowCountChanged(0, -oldCount);
		cookies = [];
		loadCookies(searchfor);
	}
}

/*** =================== COOKIES CODE =================== ***/

function Cookie(number,name,value,isDomain,host,rawHost,path,isSecure,expires,
                status,policy) {
  this.number = number;
  this.name = name;
  this.value = value;
  this.isDomain = isDomain;
  this.host = host;
  this.rawHost = rawHost;
  this.path = path;
  this.isSecure = isSecure;
  this.expires = expires;
  this.status = status;
  this.policy = policy;
}

function loadCookies(criterium, noresort) {
  if (!cookieBundle)
    cookieBundle = document.getElementById("cookieBundle");

  if (!cookiesTree)
    cookiesTree = document.getElementById("cookiesTree");

  //var dataObject = window.opener.top.hPrefWindow.wsm.dataManager.pageData[window.location.href].userData;
  //if (!('cookies' in dataObject)) {
    // load cookies into a table
    var enumerator = cookiemanager.enumerator;
    var count = 0;
    while (enumerator.hasMoreElements()) {
      var nextCookie = enumerator.getNext();
      if (!nextCookie) break;
      nextCookie = nextCookie.QueryInterface(Components.interfaces.nsICookie);
      var host = nextCookie.host;

      if (criterium && host.indexOf(criterium) == -1 ) continue;

      if (nextCookie.policy != nsICookie.POLICY_UNKNOWN) {
        showPolicyField = true;
      }
      cookies[count] =
        new Cookie(count++, nextCookie.name, nextCookie.value, nextCookie.isDomain, host,
                   (host.charAt(0)==".") ? host.substring(1,host.length) : host,
                   nextCookie.path, nextCookie.isSecure, nextCookie.expires,
                   nextCookie.status, nextCookie.policy);
    }
  //}

  cookiesTreeView.rowCount = cookies.length;
  cookiesTree.treeBoxObject.view = cookiesTreeView;

  // sort by host column
  // we need this magic to disable the switching between asc and desc search during lookup
  // it's simple: if lastCookieSortAscending is not equal column - do asc sort always
  var savelastCookieSortAscending = lastCookieSortAscending;
  lastCookieSortAscending = '';
  CookieColumnSort('rawHost', true);
  lastCookieSortAscending = savelastCookieSortAscending; 
}

function GetExpiresString(expires) {
  if (expires) {
    var date = new Date(1000*expires);
    return gDateService.FormatDateTime("", gDateService.dateFormatLong,
                                       gDateService.timeFormatSeconds, date.getFullYear(),
                                       date.getMonth()+1, date.getDate(), date.getHours(),
                                       date.getMinutes(), date.getSeconds());
  }
  return cookieBundle.getString("AtEndOfSession");
}

function GetPolicyString(policy) {
  switch (policy) {
    case nsICookie.POLICY_NONE:
      return cookieBundle.getString("policyUnstated");
    case nsICookie.POLICY_NO_CONSENT:
      return cookieBundle.getString("policyNoConsent");
    case nsICookie.POLICY_IMPLICIT_CONSENT:
      return cookieBundle.getString("policyImplicitConsent");
    case nsICookie.POLICY_EXPLICIT_CONSENT:
      return cookieBundle.getString("policyExplicitConsent");
    case nsICookie.POLICY_NO_II:
      return cookieBundle.getString("policyNoIICollected");
  }
  return "";
}

function CookieSelected()
{
	var selections = GetTreeSelections(cookiesTree);
	if( !selections.length )
	{
		ClearCookieProperties();
		UI_EnableCookieBtns(false);
		return true;
	}
    
	var idx = selections[0];
	if( idx >= cookies.length )
	{
		// Something got out of synch.  See bug 119812 for details
		dump("Tree and viewer state are out of sync! " +
			"Help us figure out the problem in bug 119812");
		UI_EnableCookieBtns(false);
		return;
	}

	// save last selected name
	prefs.setCharPref( lastsearchNameKey, cookies[idx].name );

	var props = [
		{id: "ifl_name", value: cookies[idx].name},
		{id: "ifl_value", value: cookies[idx].value}, 
		{id: "ifl_isDomain",
		value: cookies[idx].isDomain
			? cookieBundle.getString("domainColon")
			: cookieBundle.getString("hostColon") },
		{id: "ifl_host", value: cookies[idx].host},
		{id: "ifl_path", value: cookies[idx].path},
		{id: "ifl_isSecure",
		value: cookies[idx].isSecure
			? cookieBundle.getString("yes")
			: cookieBundle.getString("no") },
		{id: "ifl_expires", value: GetExpiresString(cookies[idx].expires)},
		{id: "ifl_expiresOrig", value: cookies[idx].expires},
		{id: "ifl_policy", value: GetPolicyString(cookies[idx].policy)}
	];

	var value;
	var field;
	for( var i = 0; i < props.length; i++ )
	{
		field = document.getElementById(props[i].id);
		if( (selections.length > 1) && (props[i].id != "ifl_isDomain") )
		{
			value = ""; // clear field if multiple selections
		} else {
			value = props[i].value;
		}
		field.value = value;
	}

	// make the delete button active
	UI_EnableCookieBtns(true);

	return true;
}

function ClearCookieProperties() {
  var properties = 
    ["ifl_name","ifl_value","ifl_host","ifl_path","ifl_isSecure","ifl_expires","ifl_expiresOrig","ifl_policy"];
  for (var prop=0; prop<properties.length; prop++) {
    document.getElementById(properties[prop]).value = "";
  }
}

function CookieColumnSort(column, updateview)
{
	lastCookieSortAscending = SortTree( cookiesTree, cookiesTreeView, cookies,
					column, lastCookieSortColumn, lastCookieSortAscending, updateview );
	lastCookieSortColumn = column;
}

function UI_EnableCookieBtns(flag)
{
	document.getElementById('deleteCookie').disabled = !flag;
	document.getElementById('editCookie').disabled = !flag;
}

function DeleteCookie()
{
	var deletedCookies = [];

	// remove selected items from list (by setting them to null) and place in deleted list
	var selections = GetTreeSelections( cookiesTree );
	for( var s=selections.length-1; s>= 0; s-- )
	{
		var i = selections[s];
		if( confirm( 'Are you sure to delete the \'' + cookies[i].name + ' @ ' + cookies[i].host + '\' cookie?' ))
		{
			deletedCookies[deletedCookies.length] = cookies[i];
			cookies[i] = null;
		}
	}

	// collapse list by removing all the null entries
	for (var j=0; j<cookies.length; j++)
	{
		if (cookies[j] == null)
		{
			var k = j;
			while ((k < cookies.length) && (cookies[k] == null)) k++;
			cookies.splice(j, k-j);
			cookiesTreeView.rowCount -= k - j;
			cookiesTree.treeBoxObject.rowCountChanged(j, j - k);
		}
	}

	// update selection and/or buttons
	if( cookies.length ) {

		// update selection
		var nextSelection = (selections[0] < cookies.length) ? selections[0] : cookies.length-1;
		cookiesTree.treeBoxObject.view.selection.select(nextSelection);
		cookiesTree.treeBoxObject.ensureRowIsVisible(nextSelection);
	}
	else
	{
		// disable buttons
		document.getElementById('deleteCookie').setAttribute("disabled", "true")
	}

	// and now delete cookies
	if ( deletedCookies.length )
	{
		for( var p=0; p < deletedCookies.length; ++p )
		{
			// FIXME - this method is subject to change!
			cookiemanager.remove(
				deletedCookies[p].host,
				deletedCookies[p].name,
				deletedCookies[p].path,
				false ); // not blacklist cookie
		}
	}

        if (!cookies.length)
	   ClearCookieProperties();
}

function EditCookie()
{
	window.openDialog("editCookie.xul", "_blank", "chrome,resizable=yes,modal=yes", "EditCookie");
}